#include "stdlib.h"
#include "assert.h"
#include "stdio.h"

/* Calcul de la moyenne d'un ensemble de valeurs comprises entre 0 et 100
 * La moyenne est approximee sur l'entier le plus proche
 */
int moyenne(const int* valeurs,unsigned int taille);

/* Calcul de la moyenne d'un ensemble de valeurs comprises entre 0 et 100
 * La moyenne est approximee sur l'entier le plus proche
 */
int moyenne(const int* valeurs,unsigned int taille)
{
    //Algorithme: calcul de la moyenne
    //
    // Variable moyenne <- 0
    //
    // Pour toutes les valeurs v du tableau
    //   verifier v compris entre [0,100]
    //   ajouter v a moyenne
    // Fin Pour
    //
    // Diviser moyenne par la taille du tableau
    // Arrondir a l'entier le plus proche
    //
    // Renvoyer valeur de la moyenne
    //

    assert(valeurs!=NULL);

    // Variable moyenne <- 0
    int moyenne_courante=0;

    // Pour toutes les valeurs v du tableau
    unsigned int k=0;
    for(k=0;k<taille;++k)
    {
        //   verifier v compris entre [0,100]
        int v=valeurs[k];
        assert(v>=0 && v<=100);
        //   ajouter v a moyenne
        moyenne_courante += v;
    }

    // Diviser moyenne par la taille du tableau
    float temporaire=(float)moyenne_courante/taille;
    // Arrondir a l'entier le plus proche
    moyenne_courante=(int)(temporaire+0.5);


    // Renvoyer valeur de la moyenne
    return moyenne_courante;
}

int main()
{
    int T[]={40,60,85,12,98};
    int resultat=moyenne(T,5);
    printf("%d\n",resultat);
    return 0;
}





