#include <stdio.h>
#include <math.h>
#include <assert.h>

/*Calcul le volume du cylindre de rayon R entre z=[z1,z2]
 * Le volume est obtenu par la formule V= pi (z2-z1) R*R.
 *
 * Necessite:
 *  - deux coordonnées flottantes (z1,z2) avec z2>z1
 *  - une coordonnée flottante R>0
 * Garantie:
 *  - renvoie le volume (flottant positif) correspondant au cylindre décrit
 */
float volume(float z1,float z2,float R)
{
    assert(z2>z1);
    assert(R>0);

    float V=M_PI*R*R*(z2-z1);

    assert(V>0);

    return V;
}

int main()
{
  float V1=volume(1,2,0.5);
  float V2=volume(0,10,8);
  float V3=volume(-4,8,1);
  float V4=volume(5,1,1);
  float V5=volume(1,4,-1);

  return 0;
}

