#include <stdio.h>
#include <math.h>
#include <assert.h>

/*Calcul le volume du cylindre de rayon R entre z=[z1,z2]
 * Le volume est obtenu par la formule V= pi (z2-z1) R*r.
 *
 * Necessite:
 *  - deux coordonnées flottantes (z1,z2) quelconques
 *  - une coordonnée flottante R quelconque
 * Garantie:
 *  - Si z1>z2 et R>0, renvoi un volume (flottant positif) correspondant au cylindre decrit.
 *  - Si z1=z2 ou R=0, renvoi zero
 *  - Si z1<z2 ou R<0, affiche une erreur en ligne de commande et renvoi -1
 */
float volume(float z1,float z2,float R)
{
  //cas du volume nul
  float epsilon=1e-5;
  if(fabs(z1-z2)<epsilon || fabs(R)<epsilon)
    return 0.0;
  //cas non geometrique
  if(z1<z2 || R<0)
    {printf("Erreur calcul volume\n");return -1.0;}
  //volume du cylindre
  float V=M_PI*R*R*(z2-z1);
  return V;
}

int main()
{
  float V1=volume(1,2,0.5);
  float V2=volume(0,10,8);
  float V3=volume(-4,8,1);
  float V4=volume(5,1,1);
  float V5=volume(1,4,-1);

  return 0;
}

