#include <assert.h>
#include <stdlib.h>
#include <stdio.h>

/* Calcul de la moyenne d'un ensemble de valeurs comprises entre 0 et 100
 * La moyenne est approxime sur l'entier le plus proche
 *
 * Necessite:
 *  - Un pointeur constant vers un ensemble de valeurs entieres. Pointeur non NULL.
 *    les valeurs du tableau sont comprises entre 0 et 100 (inclus)
 *  - Un entier positif indiquant la taille du tableau de donnees.
 * Garantie:
 *  - Renvoi la moyenne des valeurs du tableau (compris entre 0 et 100).
 *  - La moyenne est approximee au nombre entier le plus proche.
 */
int moyenne(const int* valeurs,unsigned int taille)
{
    assert(valeurs!=NULL);

    //somme de l'ensemble des valeurs
    int moyenne=0;
    unsigned int k=0;
    for(k=0;k<taille;++k)
    {
        int val=valeurs[k];
        assert(val>=0 && val<=100);
        moyenne += valeurs[k];
    }

    //passage en nombre flottants temporaires (virgules)
    float temporaire=(float)moyenne/taille;
    //approximation sur l'entier le plus proche
    moyenne=(int)(temporaire+0.5);

    assert(moyenne>=0 && moyenne<=100);

    return moyenne;
}

int main()
{
    int T[]={40,15,20,68,12};

    moyenne(T,5);

    return 0;
}


