
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

#define ECHEC_TEST printf("Echec ligne.%d\n",__LINE__)

/* Calcul de la moyenne d'un ensemble de valeurs comprises entre 0 et 100
 * La moyenne est approxime sur l'entier le plus proche
 */
int moyenne(const int* valeurs,unsigned int taille)
{
  assert(valeurs!=NULL);

  //cas particulier taille==0
  if(taille==0)
    return 0;

  int moyenne=0;
  unsigned int k=0;
  for(k=0;k<taille;++k)
    {
      int v=valeurs[k];
      //cas d'erreur
      if(v<0 || v>100)
          return -1;

      moyenne += v;
    }

  float temporaire=(float)moyenne/taille;
  // Arrondir a l'entier le plus proche
  moyenne=(int)(temporaire+0.5);

  return moyenne;
} 

int main()
{
    //1 valeur, attend 1
    int t1[]={50};
    if(moyenne(t1,sizeof(t1)/sizeof(int))!=50)
        ECHEC_TEST;

    //arrondie au nombre superieur, attend 72
    int t2[]={45,80,90};
    if(moyenne(t2,sizeof(t2)/sizeof(int))!=72)
        ECHEC_TEST;

    //arrondi au nombre inferieur, attend 71
    int t3[]={45,80,89};
    if(moyenne(t3,sizeof(t3)/sizeof(int))!=71)
        ECHEC_TEST;

    //valeurs constantes, attend 45
    int t4[]={45,45,45,45,45};
    if(moyenne(t4,sizeof(t4)/sizeof(int))!=45)
        ECHEC_TEST;

    //cas particulier 0 valeurs, attend 0
    int t5[0];
    if(moyenne(t5,sizeof(t5)/sizeof(int))!=0)
        ECHEC_TEST;

    //cas particulier depassement valeur < 0, attend -1
    int t6[]={5,-4};
    if(moyenne(t6,sizeof(t6)/sizeof(int))!=-1)
        ECHEC_TEST;

    //cas particulier depassement valeur > 100, attend -1
    int t7[]={8,106};
    if(moyenne(t7,sizeof(t7)/sizeof(int))!=-1)
        ECHEC_TEST;

    //cas particulier limite depassement valeur < 0, attend -1
    int t8[]={1,2,-1};
    if(moyenne(t8,sizeof(t8)/sizeof(int))!=-1)
        ECHEC_TEST;

    //cas limite, valeur==0, attend 10
    int t9[]={10,20,0};
    if(moyenne(t9,sizeof(t9)/sizeof(int))!=10)
        ECHEC_TEST;

    //cas limite particulier, valeur==101, attend -1
    int t10[]={8,101,99};
    if(moyenne(t10,sizeof(t10)/sizeof(int))!=-1)
        ECHEC_TEST;

    //cas limite, valeur==100, attend 69
    int t11[]={8,100,99};
    if(moyenne(t11,sizeof(t11)/sizeof(int))!=69)
        ECHEC_TEST;

    return 0;
}
